void
_start (void)
{
  unsigned buf[8];
  unsigned int a, b, c, d;
  int is_ia32el = 0;
  asm volatile ("cpuid"
		: "=a" (buf[0]), "=b" (buf[1]), "=c" (buf[2]), "=d" (buf[3])
		: "0" (0x80000002));
  asm volatile ("cpuid"
		: "=a" (buf[4]), "=b" (buf[5]), "=c" (buf[6]), "=d" (buf[7])
		: "0" (0x80000003));
  if (__builtin_strncmp ((char *) buf, " Intel (R) IA-32 Execution Layer", 32)
      == 0)
    is_ia32el = 1;
  else
    {
      asm volatile ("cpuid"
		    : "=a" (a), "=b" (b), "=c" (c), "=d" (d)
		    : "0" (1));
      if ((a & 0x00f00f00) == 0x00200f00)
	is_ia32el = 1;
    }
  while (1)
    asm volatile ("int $0x80" : : "a" (1), "b" (!is_ia32el));
}
